%macro dhl 1.nolist
        db (%1) >> 8
        db (%1) & 0xFF
%endmacro
%macro dhla 1.nolist
        db ((%1)-_f0) >> 8
        db ((%1)-_f0) & 0xFF
%endmacro
SECTION .data
global _f0
_f0:

;; lua: return gsub(strings.Cdefs, "#", "%%")
%define H_AT             0x00
%define H_TO             0x01
%define H_CON            0x02
%define H_COL            0x03
%define H_RSR            0x04
%define FIP_RETURN       0xFFFF
%define FIP_RSREXIT      0xFFFE
%define FIP_FIPDROP      0xFFFD
%define SF_EXIT          0xFF
%define SF_STO           0xFE
%define SF_TOS           0xFD
%define F_EXIT           0xFCFF
%define F_STO            0xFCFE
%define F_COUNT          0xFCFD
%define F_2DUP           0xFCFC
%define F_PLUS           0xFCFB
%define F_TOS            0xFCFA
%define F_TYPE           0xFCF9

;; lua: return strings.nasmbytecode
ADR_x26FOO:
	db H_AT
ADR_FOOx21:
	db H_TO
ADR_FOO:
	db H_CON
	dd 0x12345
ADR_Sx24x40x2c:
	db H_COL
	db SF_STO
	dhl F_COUNT
	dhl F_2DUP
	dhl F_PLUS
	db SF_TOS
	db SF_EXIT
ADR_x3cx2ex22x3e:
	db H_RSR
ADR_Sx3cx2ex22x3e:
	db H_COL
	dhl ADR_Sx24x40x2c -_f0
	dhl F_TYPE
	db SF_EXIT
ADR_2x3cx2ex22x3e:
	db H_RSR
ADR_S2x3cx2ex22x3e:
	db H_COL
	dhl ADR_Sx3cx2ex22x3e -_f0
	dhl ADR_Sx3cx2ex22x3e -_f0
	db SF_EXIT
    global ADR_DEMO
ADR_DEMO:
	db H_COL
	dhl ADR_2x3cx2ex22x3e -_f0
	db 6,'Hello',10,6,'There',10
	dhl ADR_FOO -_f0
	dhl ADR_FOO -_f0
	dhl F_PLUS
	dhl ADR_FOOx21 -_f0
	db SF_EXIT
