%macro dhl 1.nolist
        db (%1) >> 8
        db (%1) & 0xFF
%endmacro
%macro dhla 1.nolist
        db ((%1)-_f0) >> 8
        db ((%1)-_f0) & 0xFF
%endmacro
SECTION .data
global _f0
_f0:

;; lua: return gsub(strings.Cdefs, "#", "%%")
%define H_COL            0x00
%define H_CON            0x01
%define FIP_RETURN       0xFFFF
%define FIP_RSREXIT      0xFFFE
%define FIP_FIPDROP      0xFFFD
%define SF_EXIT          0xFF
%define SF_DUP           0xFE
%define F_EXIT           0xFDFF
%define F_DUP            0xFDFE
%define F_TIMES          0xFDFD

;; lua: return strings.nasmbytecode
ADR_SQUARE:
	db H_COL
	db SF_DUP
	dhl F_TIMES
	db SF_EXIT
ADR_CUBE:
	db H_COL
	db SF_DUP
	dhl ADR_SQUARE -_f0
	dhl F_TIMES
	db SF_EXIT
ADR_2:
	db H_CON
	dd 2
    global ADR_DEMO
ADR_DEMO:
	db H_COL
	dhl ADR_2 -_f0
	dhl ADR_CUBE -_f0
	db SF_EXIT
